# ===== tankanji.dic の内容をテキストファイル (UTF-8) で出力する =====
#
#  2014-04-27 版
#  http://hashimo.ddo.jp/
#

  use strict;
  use warnings;
  use utf8;

  our (%tbl, $yomi);
  my ($c, $outf);

  binmode STDOUT, ':raw:encoding(cp932)';
  binmode STDERR, ':raw:encoding(cp932)';
  binmode STDIN, ':raw:encoding(cp932)';

  if ($#ARGV == 0) {
    $outf = $ARGV[0];
  }
  else {
    die '出力ファイル名を1つ指定して下さい';
  }

  unless (open FP, '< tankanji.dic') {
    die 'tankanji.dic を開けません';
  }
  binmode FP;

  unless (read(FP, $c, 8)) {
    die 'readに失敗しました';
  }
  if ($c ne 'TANKANJI') {
    die '辞書ファイルではありません';
  }
  unless (read(FP, $c, 8)) {
    die 'readに失敗しました';
  }
  if ($c ne '20070404') {
    die '辞書ファイルのバージョンが違います';
  }

  %tbl = ();       # 読み→漢字 ハッシュ

  while (1) {
    my ($filepos);
    unless (read(FP, $c, 2)) {
      die 'readに失敗しました';
    }
    $c = &cv($c);
    last if ($c == 0);
    $yomi = chr($c);
    unless (read(FP, $c, 3)) {
      die 'readに失敗しました';
    }
    $c = &cv($c);
    $filepos = tell FP;
    unless(seek FP, $c, 0) {
      die 'seekに失敗しました';
    }
    &oneblock();
    seek FP, $filepos, 0;
  }

  close FP;

  unless (open FP, '>:utf8', $outf) {
    die $outf . 'に書き込めません';
  }

  foreach $c (sort keys %tbl) {
    my ($i, $k);
    $k = $tbl{$c};
    for ($i = 0; $i < length($k); $i ++) {
      print FP $c;
      print FP "\t";
      print FP substr($k, $i, 1);
      print FP "\n";
    }
  }

  close FP;

sub oneblock {
  my ($c);

  while (1) {
    unless (read(FP, $c, 2)) {
      die 'readに失敗しました';
    }
    $c = &cv($c);
    last if ($c == 0);
    $tbl{$yomi} .= chr($c);
  }

  while (1) {
    my ($filepos);
    unless (read(FP, $c, 2)) {
      die 'readに失敗しました';
    }
    $c = &cv($c);
    last if ($c == 0);
    $yomi .= chr($c);
    unless (read(FP, $c, 3)) {
      die 'readに失敗しました';
    }
    $c = &cv($c);
    $filepos = tell FP;
    unless(seek FP, $c, 0) {
      die 'seekに失敗しました';
    }
    &oneblock();
    seek FP, $filepos, 0;
    chop $yomi;
  }
}

sub cv {
  # 文字列(BigEndian)を符号無し整数にする
  my ($dat) = @_;
  my ($i, $rv);
  $rv = 0;
  for ($i = 0; $i < length($dat); $i ++) {
    my ($c);
    $c = substr($dat, $i, 1);
    $rv = $rv * 256 + ord($c);
  }
  return $rv;
}

__END__
